diff --git a/controller/ovn-controller.8.xml b/controller/ovn-controller.8.xml
index cb47c9bd1..eb2950723 100644
--- a/controller/ovn-controller.8.xml
+++ b/controller/ovn-controller.8.xml
@@ -480,7 +480,7 @@
           logical port. Its value is the name of the logical port with type
           set to <code>l3gateway</code>. This patch port is similar to
           the OVN logical patch port, except that <code>l3gateway</code>
-          port can only be bound to a paticular chassis.
+          port can only be bound to a particular chassis.
         </p>
       </dd>
 
diff --git a/northd/ovn-northd.8.xml b/northd/ovn-northd.8.xml
index 3d1e7357d..40bda7ead 100644
--- a/northd/ovn-northd.8.xml
+++ b/northd/ovn-northd.8.xml
@@ -449,7 +449,7 @@
       datapaths to move traffic to the next table. Where <var>E</var>
       is the service monitor mac defined in the
       <ref column="options:svc_monitor_mac" table="NB_Global"
-      db="OVN_Northbound"/> colum of <ref table="NB_Global"
+      db="OVN_Northbound"/> column of <ref table="NB_Global"
       db="OVN_Northbound"/> table.
     </p>
 
@@ -514,7 +514,7 @@
       datapaths to move traffic to the next table. Where <var>E</var>
       is the service monitor mac defined in the
       <ref column="options:svc_monitor_mac" table="NB_Global"
-      db="OVN_Northbound"/> colum of <ref table="NB_Global"
+      db="OVN_Northbound"/> column of <ref table="NB_Global"
       db="OVN_Northbound"/> table.
     </p>
 
@@ -708,7 +708,7 @@
       if the logical switch has <code>no</code> ACLs configured, otherwise a
       priority-0 flow to advance to the next table so that ACLs allow
       packets by default if <ref column="options:default_acl_drop"
-      table="NB_Global" db="OVN_Northbound"/> colum of <ref table="NB_Global"
+      table="NB_Global" db="OVN_Northbound"/> column of <ref table="NB_Global"
       db="OVN_Northbound"/> is <code>false</code> or not set.  Otherwise
       the flow action is set to <code>drop;</code> to implement a default
       drop behavior.
@@ -722,7 +722,7 @@
     <ul>
       <li>
         If <ref column="options:default_acl_drop" table="NB_Global"
-        db="OVN_Northbound"/> colum of <ref table="NB_Global"
+        db="OVN_Northbound"/> column of <ref table="NB_Global"
         db="OVN_Northbound"/> is <code>false</code> or not set, a priority-1
         flow that sets the hint to commit IP traffic that is not part of
         established sessions to the connection tracker (with action
@@ -734,7 +734,7 @@
 
       <li>
         If <ref column="options:default_acl_drop" table="NB_Global"
-        db="OVN_Northbound"/> colum of <ref table="NB_Global"
+        db="OVN_Northbound"/> column of <ref table="NB_Global"
         db="OVN_Northbound"/> is <code>true</code>, a priority-1
         flow that drops IP traffic that is not part of established
         sessions.
@@ -808,7 +808,7 @@
         with the action <code>next</code>, where <var>E</var> is the
         service monitor mac defined in the
         <ref column="options:svc_monitor_mac" table="NB_Global"
-        db="OVN_Northbound"/> colum of <ref table="NB_Global"
+        db="OVN_Northbound"/> column of <ref table="NB_Global"
         db="OVN_Northbound"/> table.
       </li>
     </ul>
@@ -1655,7 +1655,7 @@ output;
         datapaths and applies the action <code>handle_svc_check(inport)</code>.
         Where <var>E</var> is the service monitor mac defined in the
         <ref column="options:svc_monitor_mac" table="NB_Global"
-        db="OVN_Northbound"/> colum of <ref table="NB_Global"
+        db="OVN_Northbound"/> column of <ref table="NB_Global"
         db="OVN_Northbound"/> table.
       </li>
 
@@ -1866,7 +1866,7 @@ output;
       a match of <code>ip</code> and action of <code>reg0[2] = 1; next;</code>
       to act as a hint for table <code>Pre-stateful</code> to send IP packets
       to the connection tracker for packet de-fragmentation and possibly DNAT
-      the destination VIP to one of the selected backend for already commited
+      the destination VIP to one of the selected backend for already committed
       load balanced traffic.
     </p>
 
@@ -1876,7 +1876,7 @@ output;
       datapaths to move traffic to the next table. Where <var>E</var>
       is the service monitor mac defined in the
       <ref column="options:svc_monitor_mac" table="NB_Global"
-      db="OVN_Northbound"/> colum of <ref table="NB_Global"
+      db="OVN_Northbound"/> column of <ref table="NB_Global"
       db="OVN_Northbound"/> table.
     </p>
 
@@ -1893,7 +1893,7 @@ output;
       datapaths to move traffic to the next table. Where <var>E</var>
       is the service monitor mac defined in the
       <ref column="options:svc_monitor_mac" table="NB_Global"
-      db="OVN_Northbound"/> colum of <ref table="NB_Global"
+      db="OVN_Northbound"/> column of <ref table="NB_Global"
       db="OVN_Northbound"/> table.
     </p>
 
@@ -1973,7 +1973,7 @@ output;
         with the action <code>next</code>, where <var>E</var> is the
         service monitor mac defined in the
         <ref column="options:svc_monitor_mac" table="NB_Global"
-        db="OVN_Northbound"/> colum of <ref table="NB_Global"
+        db="OVN_Northbound"/> column of <ref table="NB_Global"
         db="OVN_Northbound"/> table.
       </li>
     </ul>
@@ -4498,7 +4498,7 @@ nd_ns {
         A priority-120 flow to advance the IPv6 Neighbor solicitation packet
         to next table to skip SNAT. In the case where ovn-controller injects
         an IPv6 Neighbor Solicitation packet (for <code>nd_ns</code> action)
-        we don't want the packet to go throught conntrack.
+        we don't want the packet to go through conntrack.
       </li>
     </ul>
 
diff --git a/ovn-architecture.7.xml b/ovn-architecture.7.xml
index a48757761..b2e00d6e4 100644
--- a/ovn-architecture.7.xml
+++ b/ovn-architecture.7.xml
@@ -1613,7 +1613,7 @@
     8 to 65 again, this time using the logical datapath representing the
     logical router.  The processing continues as described in the previous
     section <code>Architectural Physical Life Cycle of a Packet</code>.
-    When the packet reachs table 65, the logical egress port will once
+    When the packet reaches table 65, the logical egress port will once
     again be a logical patch port.  In the same manner as described above,
     this logical patch port will cause the packet to be resubmitted to
     OpenFlow tables 8 to 65, this time using the logical datapath
@@ -2262,7 +2262,7 @@
       OVN_Southbound</code> database.  Note, the <var>tunnel_key</var>
       column of VTEP logical switch is not filled at creation.  The
       <code>ovn-controller-vtep</code> will set the column when the
-      correponding vtep logical switch is bound to an OVN logical network.
+      corresponding vtep logical switch is bound to an OVN logical network.
     </li>
 
     <li>
@@ -2389,7 +2389,7 @@
       keys locally assigned for datapaths within each AZ.
     </li>
     <li>
-      Availability zones, which are registerd by <code>ovn-ic</code>
+      Availability zones, which are registered by <code>ovn-ic</code>
       from each AZ.
     </li>
     <li>
diff --git a/ovn-ic-sb.xml b/ovn-ic-sb.xml
index 2966975c7..f7e17e113 100644
--- a/ovn-ic-sb.xml
+++ b/ovn-ic-sb.xml
@@ -117,7 +117,7 @@
     </column>
 
     <column name="availability_zone">
-      The availabilty zone that the gateway belongs to.
+      The availability zone that the gateway belongs to.
     </column>
 
     <column name="hostname">
diff --git a/ovn-nb.xml b/ovn-nb.xml
index e26afd83c..956b131c3 100644
--- a/ovn-nb.xml
+++ b/ovn-nb.xml
@@ -167,7 +167,7 @@
         Traffic into OVS can raise a 'controller' event that results in a
         Controller_Event being written to the <ref table="Controller_Event"/>
         table in SBDB. When the CMS has seen the event and taken appropriate
-        action, it can remove the correponding row in
+        action, it can remove the corresponding row in
         <ref table="Controller_Event"/> table.
         The intention is for a CMS to see the events and take some sort of
         action. Please see the <ref table="Controller_Event"/> table in SBDB.
@@ -2846,7 +2846,7 @@
 
       <column name="ipv6_ra_configs" key="route_info">
         Route Info is used to configure Route Info Option sent in Router
-        Advertisment according to RFC 4191. Route Info is a comma
+        Advertisement according to RFC 4191. Route Info is a comma
         separated string where each field provides PRF and prefix for a
         given route (e.g: HIGH-aef1::11/48,LOW-aef2::11/96)
         Possible PRF values are:
diff --git a/ovn-sb.xml b/ovn-sb.xml
index 59ad3aa2d..f7424f144 100644
--- a/ovn-sb.xml
+++ b/ovn-sb.xml
@@ -3144,7 +3144,7 @@ tcp.flags = RST;
           <dd>
             Represents a logical port with an <code>virtual ip</code>.
             This <code>virtual ip</code> can be configured on a
-            logical port (which is refered as virtual parent).
+            logical port (which is referred as virtual parent).
           </dd>
         </dl>
       </column>
diff --git a/utilities/ovn-ctl.8.xml b/utilities/ovn-ctl.8.xml
index 42d16fabc..82804096f 100644
--- a/utilities/ovn-ctl.8.xml
+++ b/utilities/ovn-ctl.8.xml
@@ -308,7 +308,8 @@
       </code>
     </p>
 
-    <h2>Passing ssl keys when starting OVN dbs will supercede the default ssl values in db</h2>
+    <h2>Passing ssl keys when starting OVN dbs will supersede the default ssl
+        values in db</h2>
     <h3>Starting standalone ovn db server passing SSL certificates</h3>
     <p>
       <code>
diff --git a/utilities/ovn-nbctl.8.xml b/utilities/ovn-nbctl.8.xml
index 040d05227..5f9eb186b 100644
--- a/utilities/ovn-nbctl.8.xml
+++ b/utilities/ovn-nbctl.8.xml
@@ -226,7 +226,7 @@
         connect.  The remotes will be shuffled only once to a new order before
         the first connection attempt.  The following retries, if any, will
         follow the same new order.  The default behavior is to make sure
-        clients of a clustered database can distribute evenly to all memembers
+        clients of a clustered database can distribute evenly to all members
         of the cluster.  With <code>--no-shuffle-remotes</code>,
         <code>ovn-nbctl</code> will use the original order specified in the
         connection string to connect.  This allows user to specify the
@@ -492,7 +492,7 @@
 
         <p>
           If <var>switch</var> and <var>uuid</var> are supplied, then the
-          QoS rule with sepcified uuid is deleted.
+          QoS rule with specified uuid is deleted.
         </p>
       </dd>
 
@@ -1127,7 +1127,7 @@
 
         <p>
           If <var>router</var> and <var>uuid</var> are supplied, then the
-          policy with sepcified uuid is deleted. It is an error if
+          policy with specified uuid is deleted. It is an error if
           <var>uuid</var> does not exist, unless <code>--if-exists</code>
           is specified.
         </p>
@@ -1237,7 +1237,7 @@
           the fields will be deleted. When <var>type</var> is
           <code>snat</code>, the <var>ip</var> should be logical_ip. When
           <var>type</var> is <code>dnat</code> or <code>dnat_and_snat</code>,
-          the <var>ip</var> shoud be external_ip.
+          the <var>ip</var> should be external_ip.
         </p>
 
         <p>
diff --git a/utilities/ovn-sbctl.8.xml b/utilities/ovn-sbctl.8.xml
index 4d2ea596a..81ab4131d 100644
--- a/utilities/ovn-sbctl.8.xml
+++ b/utilities/ovn-sbctl.8.xml
@@ -185,7 +185,7 @@
         connect.  The remotes will be shuffled only once to a new order before
         the first connection attempt.  The following retries, if any, will
         follow the same new order.  The default behavior is to make sure
-        clients of a clustered database can distribute evenly to all memembers
+        clients of a clustered database can distribute evenly to all members
         of the cluster.  With <code>--no-shuffle-remotes</code>,
         <code>ovn-sbctl</code> will use the original order specified in the
         connection string to connect.  This allows user to specify the